/*
 * GIJO panel definition for Berkeley Yacc.
 */

filetype { 'TEXT' }

gijo {{
	90,									/* height of the dialog in pixels */
	"Berkeley Yacc: an LALR(1) parser generator.",			/* help string */
	{
/*1*/	notDependent{},
		CheckOption{
			NotSet, {20,18,36,195}, "Generate header","-d",
			"If set, Yacc will generate a header file called "
			".tab.h (where  is the specified filename prefix)"
		},

/*2*/	notDependent{},
		CheckOption{
			NotSet,{36,18,52,195}, "Generate description","-v",
			"If set, Yacc will generate a human-readable description "
			"of the generated parser in the file .output (where  is "
			"the specified filename prefix)."
		},

/*3*/	notDependent{},
		CheckOption{
			Set,{52,18,68,195}, "Include #lines","-l",
			"Yacc will include #line directives in the output file "
			"if this option is set.  These directives should only be "
			"included if the C compiler supports them.  #line "
			"directives specified by the user will be retained."
		},

/*4*/	notDependent{},
		CheckOption{
			NotSet,{68,18,84,195},"Debug code included","-t",
			"If set, Yacc will include debugging statements into the "
			"generated parser code."
		},

/*5*/	notDependent{},
		CheckOption{
			NotSet,{20,200,36,460},"Seperate code & tables files","-r",
			"If set, Yacc will generate distinct files for code & tables "
			"called respectively .code.c and .tab.c (where  is the "
			"specified filename prefix)."
		},

/*6*/	notDependent{},
		RegularEntry{
			"Filename prefix:", {40,200,56,290},{40,318,56,460},
			"y", keepCase, "-b",
			"This option specifies the prefix used in all output "
			"filenames."
		},

/*7*/	notDependent{},
		RegularEntry{
			"Symbol prefix:",	{64,200,80,290},{64,318,80,460},
			"yy",keepCase,"-p",
			"This option specifies the prefix prepended to all Yacc "
			"generated symbols."
		},

/*8*/	notDependent{}, VersionDialog{
			VersionString{"1.9"},
			"Berkeley Yacc 1.9 by robert.corbett@eng.Sun.COM"
			"\n\nMac interface by Jeff Laing <jeffl@suburbia.apana.org.au>",
			0
		},

/*9*/	Or{{6}}, DoItButton{}

	}
}}