/*
 * FileTypes.h
 *
 * Suffix mappings and file types
 * August 15, 1995
 * (c)1995 SPDsoft <MacSPD@ivo.cps.unizar.es>
 *
 */

/*
 * struct for Fetch suffix mappings
 */

#ifndef __ICAPI__
#include "ICAPI.h"
#endif

typedef struct
{
		Size		FPrefsSize;
		Handle		FPrefs;
		ICInstance	ICinst;
		Handle		ICmappings;
		OSType		Type;
		OSType		Creator;
		short		Binary;
		short		MacFile;
		char		Suffix[32];
#ifdef	GET_DESC
		char		Description[256]; /* useless for me */
#endif
		Boolean		Found;
} TSufMap, *TSufMapPtr;




Boolean InitFetchMappings( Size *FPrefsSize, Handle *FPrefs );
void DisposeFetchMappings( Size *FPrefsSize, Handle *FPrefs );


Boolean InitICMappings( ICInstance *inst, Handle *ICmappings );
void DisposeICMappings( ICInstance *inst, Handle *ICmappings );


OSErr ResolveFileType( FSSpec *fSpec, char *fName, TSufMapPtr SufMapPtr, short Select );

/* Select masks */

#define kRFTUpload		0x0100
#define kRFTDownload	0x0200

#define kRFTFromName	0x0400
#define kRFTFromSpec	0x0800

#define kRFTIC			0x0001
#define kRFTFetch		0x0002
