/*
 * Globals.h
 */
 
#ifndef __PREFS_H__
#include "Prefs.h"
#endif

#define kTicksCursor		20

 
/* The structure of an 'acur' resource */

typedef struct
{
	short			numberOfFrames;		/* number of cursors to animate */
	short			whichFrame;			/* current frame number */
	CursHandle		frame[1];			/* Pointer to the first cursor */
} acur, *acurPtr, **acurHandle;


typedef struct
{
	Handle			MenuBar;
	acurHandle		Cursor;
	Boolean			StartupFiles;
	Boolean			PrefsChanged;
	Boolean			Working;
	Boolean			InForeground;
	Boolean			quit;
	Boolean			Prompt;
	short			KeysMode;
	short			KeysOp;
	short			Op;
	AliasHandle		DFolder;
	Boolean			hasColorQD;
} AppStatus;

#define	kAppKeyASCII	1
#define	kAppKeyBin		2
#define	kAppKeyMBin		3

/*
 * Globals
 */
 
extern PrefsType			gPrefs;
extern AppStatus			gApp;
extern TSufMap				gSufMap;

void MyBeep( short theSound );

acurHandle InitAnimatedCursor(short acurID);
void ReleaseAnimatedCursor(acurHandle *FrameListPtr);
void ZeroAnimatedCursor(acurHandle FrameList);
void UpdateAnimatedCursor(acurHandle FrameList, long int nowTicks);

Boolean EventLoop( void );
void InitMovableModal(long int theEnd, long *now );
void SetMMString( const char *fmt, ... );
void ReleaseMovableModal(void);


#define DoSystemTask() { if (EventLoop()) abort_gzip(); }