/*
 * MacBinary II+ stuff
 * From Peter N. Lewis (MacBinary II+ 1.0.0 crc.a)
 */

#ifndef _MACBINARY_H_
#define _MACBINARY_H_

#if defined(powerc) || defined (__powerc)
#pragma options align=mac68k
#endif

typedef struct 
	{
		Str63	name;
		OSType	ftype;
		OSType	fcreator;
		char	flags_high;
		char	zero1;
		Point	flocation;
		short	windowID;
		char	protected;
		char	zero2;
		long	dlen;
		long	rlen;
		long	create_date;
		long	mod_date;
		short	clen;
		char	flags_low;
	} MBIIStartHeader;
	
typedef struct 
	{
		signed char		version;
		signed char		MBIIStart;
		char			space[112];
		long			total_unpack_len;
		long			second_header_len;
		char			versionII;
		char			minversionII;
		short			crc;
		short			processorID;
	} MBIIHeader;
	
	
#if defined(powerc) || defined(__powerc)
#pragma options align=reset
#endif


enum {
	PT_None,
	PT_StartBlock,
	PT_EndBlock,
	PT_File
	};
	
#define	macbin_folder_ftype			((OSType)'fold')
#define	macbin_folder_creator_start	((OSType)-1)
#define	macbin_folder_creator_end	((OSType)-2)

OSErr MBHeaderFromFSSpec( FSSpec *myFSSpec, MBIIStartHeader *start, MBIIHeader *header);
OSErr SetCatInfoFromMBHeader( FSSpec *myFSSpec, MBIIStartHeader *start, MBIIHeader *header);
short ValidateMBHeader( MBIIStartHeader *start, MBIIHeader *header, Boolean handle2plus );


#endif