
/*
 *  console.h
 *
 *  Copyright (c) 1991 Symantec Corporation.  All rights reserved.
 *
 */

#pragma once

#include "stdio.h"

#define console_options		__console_options
#define fopenc				__fopenc
#define freopenc			__freopenc
#define cgotoxy				__cgotoxy
#define cgetxy				__cgetxy
#define ccleos				__ccleos
#define ccleol				__ccleol
#define csettabs			__csettabs
#define csetmode			__csetmode
#define cinverse			__cinverse
#define cshow				__cshow
#define chide				__chide
#define cecho2file			__cecho2file
#define cecho2printer		__cecho2printer
#define ccommand			__ccommand

extern struct __copt {
	short				top;
	short				left;
	unsigned char		*title;
	short				procID;
	short				txFont;
	short				txSize;
	short				txFace;
	short				nrows;
	short				ncols;
	short				pause_atexit;
} console_options;

enum { C_RAW, C_CBREAK, C_NOECHO, C_ECHO };

FILE *fopenc(void);
FILE *freopenc(FILE *, FILE *);
void cgotoxy(int, int, FILE *);
void cgetxy(int *, int *, FILE *);
void ccleos(FILE *);
void ccleol(FILE *);
void csettabs(int, FILE *);
void csetmode(int, FILE *);
void cinverse(int, FILE *);
void cshow(FILE *);
void chide(FILE *);
void cecho2file(char *, int, FILE *);
void cecho2printer(FILE *);
int ccommand(char ***);
