/* Title: Teapot.r
	* Author: David Phillip Oster
	Synopsis: Resources for the teapot graphics package
*/
#include <Types.r>
#include "TeapotRes.h"

#define kAllItems	0x7FFFFFFF
#define kItem1		(1 << (1 - 1))
#define kItem2		(1 << (2 - 1))
#define kItem3		(1 << (3 - 1))
#define kItem4		(1 << (4 - 1))
#define kItem5		(1 << (5 - 1))
#define kItem6		(1 << (6 - 1))
#define kItem7		(1 << (7 - 1))
#define kItem8		(1 << (8 - 1))
#define kItem9		(1 << (9 - 1))


/* 128k ROM and newer window template
 */
resource 'WIND' (rWin, purgeable) {
	{44, 40, 335, 508},
	documentProc,
	invisible,
	-1,
	0x0,
	"Teapot"
};

resource 'MENU' (kAppleMenu, "kAppleMenu") {
	kAppleMenu,
	textMenuProc,
	kAllItems - kItem2,
	enabled,
	apple,
	{
		"About Teapot", noIcon, noKey, noMark, plain,
		"-", noIcon, noKey, noMark, plain
}};


resource 'MENU' (kFileMenu, "kFileMenu") {
	kFileMenu,
	textMenuProc,
	kAllItems - kItem2,
	enabled,
	"File",
	{
		"Draw Teapot Again", noIcon, "D", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Quit", noIcon, "Q", noMark, plain,
}};

resource 'MENU' (kEditMenu, "kEditMenu") {
	kEditMenu,
	textMenuProc,
	kAllItems - (kItem2 |(kItem1|kItem3|kItem4|kItem5|kItem6)),
	enabled,
	"Edit",
	{	
		"Undo", noIcon, "Z", noMark, plain,
		"-", noIcon, noKey, noMark, plain,
		"Cut", noIcon, "X", noMark, plain,
		"Copy", noIcon, "C", noMark, plain,
		"Paste", noIcon, "V", noMark, plain,
		"Clear", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (kPitchMenu, "kPitchMenu") {
	kPitchMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Pitch",
	{
	"\0x00-80 x", noIcon, noKey, noMark, plain,
	"\0x00-60 x", noIcon, noKey, noMark, plain,
	"\0x00-40 x", noIcon, noKey, noMark, plain,
	"\0x00-20 x", noIcon, noKey, noMark, plain,
	"0 x", noIcon, noKey, noMark, plain,
	"20 x", noIcon, noKey, noMark, plain,
	"30 x", noIcon, noKey, noMark, plain,
	"40 x", noIcon, noKey, noMark, plain,
	"45 x", noIcon, noKey, noMark, plain,
	"50 x", noIcon, noKey, noMark, plain,
	"60 x", noIcon, noKey, noMark, plain,
	"70 x", noIcon, noKey, noMark, plain,
	"80 x", noIcon, noKey, noMark, plain,
	"90 x", noIcon, noKey, noMark, plain,
	"110 x", noIcon, noKey, noMark, plain,
	"135 x", noIcon, noKey, noMark, plain,
	"155 x", noIcon, noKey, noMark, plain,
	"170 x", noIcon, noKey, noMark, plain
}};

resource 'MENU' (kYawMenu, "kYawMenu") {
	kYawMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Yaw",
	{
	"\0x00-80 y", noIcon, noKey, noMark, plain,
	"\0x00-60 y", noIcon, noKey, noMark, plain,
	"\0x00-40 y", noIcon, noKey, noMark, plain,
	"\0x00-20 y", noIcon, noKey, noMark, plain,
	"0 y", noIcon, noKey, noMark, plain,
	"20 y", noIcon, noKey, noMark, plain,
	"30 y", noIcon, noKey, noMark, plain,
	"40 y", noIcon, noKey, noMark, plain,
	"45 y", noIcon, noKey, noMark, plain,
	"50 y", noIcon, noKey, noMark, plain,
	"60 y", noIcon, noKey, noMark, plain,
	"70 y", noIcon, noKey, noMark, plain,
	"80 y", noIcon, noKey, noMark, plain,
	"90 y", noIcon, noKey, noMark, plain,
	"110 y", noIcon, noKey, noMark, plain,
	"135 y", noIcon, noKey, noMark, plain,
	"155 y", noIcon, noKey, noMark, plain,
	"170 y", noIcon, noKey, noMark, plain
}};

resource 'MENU' (kRollMenu, "kRollMenu") {
	kRollMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Roll",
	{
	"\0x00-80 z", noIcon, noKey, noMark, plain,
	"\0x00-60 z", noIcon, noKey, noMark, plain,
	"\0x00-40 z", noIcon, noKey, noMark, plain,
	"\0x00-20 z", noIcon, noKey, noMark, plain,
	"0 z", noIcon, noKey, noMark, plain,
	"20 z", noIcon, noKey, noMark, plain,
	"30 z", noIcon, noKey, noMark, plain,
	"40 z", noIcon, noKey, noMark, plain,
	"45 z", noIcon, noKey, noMark, plain,
	"50 z", noIcon, noKey, noMark, plain,
	"60 z", noIcon, noKey, noMark, plain,
	"70 z", noIcon, noKey, noMark, plain,
	"80 z", noIcon, noKey, noMark, plain,
	"90 z", noIcon, noKey, noMark, plain,
	"110 z", noIcon, noKey, noMark, plain,
	"135 z", noIcon, noKey, noMark, plain,
	"155 z", noIcon, noKey, noMark, plain,
	"170 z", noIcon, noKey, noMark, plain
}};

resource 'MENU' (kViewMenu, "kViewMenu") {
	kViewMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"View",
	{
	"0", noIcon, noKey, noMark, plain,
	"5", noIcon, noKey, noMark, plain,
	"10", noIcon, noKey, noMark, plain,
	"20 ", noIcon, noKey, noMark, plain,
	"45 ", noIcon, noKey, noMark, plain,
	"65 ", noIcon, noKey, noMark, plain,
	"80", noIcon, noKey, noMark, plain,
	"90", noIcon, noKey, noMark, plain,
	"100", noIcon, noKey, noMark, plain,
	"110", noIcon, noKey, noMark, plain,
	"135", noIcon, noKey, noMark, plain,
	"155", noIcon, noKey, noMark, plain,
	"179", noIcon, noKey, noMark, plain
}};

resource 'MENU' (kSmoothMenu, "kSmoothMenu") {
	kSmoothMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Smooth",
	{
	"1 pt. per patch", noIcon, noKey, noMark, plain,
	"2 pts. per patch", noIcon, noKey, noMark, plain,
	"3 pts. per patch", noIcon, noKey, noMark, plain,
	"4 pts. per patch", noIcon, noKey, noMark, plain,
	"5 pts. per patch", noIcon, noKey, noMark, plain,
	"6 pts. per patch", noIcon, noKey, noMark, plain,
	"7 pts. per patch", noIcon, noKey, noMark, plain,
	"8 pts. per patch", noIcon, noKey, noMark, plain,
	"9 pts. per patch", noIcon, noKey, noMark, plain,
	"10 pts. per patch", noIcon, noKey, noMark, plain,
	"11 pts. per patch", noIcon, noKey, noMark, plain,
	"12 pts. per patch", noIcon, noKey, noMark, plain,
	"13 pts. per patch", noIcon, noKey, noMark, plain,
	"14 pts. per patch", noIcon, noKey, noMark, plain,
	"15 pts. per patch", noIcon, noKey, noMark, plain
}};

resource 'MENU' (kScaleMenu, "kScaleMenu") {
	kScaleMenu,
	textMenuProc,
	allEnabled,
	enabled,
	"Scale",
	{
	"1", noIcon, noKey, noMark, plain,
	"2", noIcon, noKey, noMark, plain,
	"3", noIcon, noKey, noMark, plain,
	"4", noIcon, noKey, noMark, plain,
	"5", noIcon, noKey, noMark, plain,
	"6", noIcon, noKey, noMark, plain,
	"7", noIcon, noKey, noMark, plain,
	"8", noIcon, noKey, noMark, plain,
	"9", noIcon, noKey, noMark, plain,
	"10", noIcon, noKey, noMark, plain
}};

/* define the menu bar to be all the above menus.
	program requires that menus be consecutive.
 */
resource 'MBAR' (kMBAR, purgeable) {{
		kAppleMenu,
		kFileMenu,
		kEditMenu,
		kPitchMenu,
		kYawMenu,
		kRollMenu,
		kViewMenu,
		kSmoothMenu,
		kScaleMenu
}};


resource 'ALRT' (rAbout, "About", purgeable) {
	{42, 13, 227, 321},
	rAbout,
	{	OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1,
		OK, visible, sound1	
}};
  
resource 'DITL' (rAbout, "About", purgeable) {{
	{152, 24, 172, 84},	Button {	enabled,	"OK"	},
	{14, 24, 80, 318},	StaticText {disabled,	"Teapot 3-D, Version 1.0\n"
		"A 3-D graphics package for LightSpeed C Version 2\n"
		"1986 by David Phillip Oster\n"},
	{80, 24, 180, 318},	StaticText {disabled,	
		"Ported to THINK C 7 by David Phillip Oster 1995\n"
		"Mosaic Codes\nSuite 2036,\n2140 Shattuck Ave.\nBerkeley, Ca. 94704"}
}};


